<?php

    lt_include(PLOG_CLASS_PATH."class/action/blogaction.class.php");
    lt_include(PLOG_CLASS_PATH."plugins/subscribe/class/view/pluginsubscriberequestconfirmationview.class.php");
    lt_include(PLOG_CLASS_PATH."class/view/errorview.class.php");
    lt_include(PLOG_CLASS_PATH."class/config/config.class.php");
    lt_include(PLOG_CLASS_PATH."class/data/validator/emailvalidator.class.php");
    lt_include(PLOG_CLASS_PATH."class/data/validator/arrayvalidator.class.php");

    class PluginSubscribeRegisterAction extends BlogAction
    {
        function PluginSubscribeRegisterAction($actionInfo, $request){
            $this->BlogAction($actionInfo, $request);

            $this->registerFieldValidator("subscribeEmail", new EmailValidator());
            $this->registerFieldValidator("subscribeCategories", new ArrayValidator());
                // todo: check if at least one category is selected

            $view = new ErrorView($this->_blogInfo);
			$view->setErrorMessage($this->_locale->tr("subscribe_missing_required_info"));
			$this->setValidationErrorView($view);
            return true;
        }

		function perform(){
			$blogSettings = $this->_blogInfo->getSettings();
            $enabled = $blogSettings->getValue("plugin_subscribe_enabled", false);
            if(!$enabled){
                $this->_view = new ErrorView($this->_blogInfo);
                $this->_view->setErrorMessage($this->_locale->tr("subscribe_disabled"));
                $this->setCommonData();
                return false;
            }                        

            $registerCategories = $this->_request->getValue("subscribeCategories");
            $emailAddress = $this->_request->getValue("subscribeEmail");

                // save subscription info to database
            if(!Subscriptions::addSubscriptions($this->_blogInfo,
                                                $registerCategories,
                                                SUBSCRIBE_POSTS_IN_CATEGORY,
                                                $emailAddress)){
                $this->_view = new ErrorView($this->_blogInfo);
                $this->_view->setErrorMessage($this->_locale->tr("subscribe_error_subscribing"));
                $this->setCommonData();
                return false;

            }

            if(Subscriptions::sendConfirmationEmail($this->_blogInfo,
                                               $emailAddress))
            {
                $this->_view = new PluginSubscribeRequestConfirmationView($this->_blogInfo);
                $this->_view->setSuccessMessage(
                    $this->_locale->tr("subscribe_confirm_subscription"));
                $this->setCommonData();
                return true;
            }
            else{
                $this->_view = new ErrorView($this->_blogInfo);
                $this->_view->setErrorMessage(
                    $this->_locale->tr("subscribe_couldnt_send_confirmation"));
                $this->setCommonData();
                return false;
            }
        }
    }
?>